<?php

  /*  Litebook ( !) */
  define("VERSION", "1.0.0");
  
  function gbook_open()
  /*     
        ,    */
  {
    global $dbname;
    $db = sqlite_open($dbname) or exit(" / !");
    
    //  ? !
    $q = sqlite_query($db, "SELECT name FROM sqlite_master " .
    "WHERE TYPE='table' AND TBL_NAME='messages'");
    if (!$q or !sqlite_fetch_array($q))
    {
      //  
      sqlite_query($db, "CREATE TABLE messages (id INTEGER PRIMARY KEY, " .
      "name TEXT, email TEXT, icq TEXT, url TEXT, message TEXT, answer TEXT, " .
      " posted INTEGER, ip TEXT, fromc TEXT);");
      //      smiles
      sqlite_query($db, "CREATE TABLE smiles (id INTEGER PRIMARY KEY, " .
      "file TEXT, mask TEXT);");
      $dir = opendir("./smiles/"); $result = "";
      while (($res = readdir($dir)) !== false)
      {
        if ($res !== ".." and $res !== ".")
        $files[] = $res;
      }
      foreach($files as $v)
      {
        $v1 = str_replace(".gif", "", $v);
        sqlite_query($db, "INSERT INTO smiles (id, file, mask) " .
        "VALUES (NULL, '$v', '*$v1')");
      }
    }
    return $db;
  }
  
  function gbook_add($db, $name, $email, $icq, $url, $message, $from)
  /*       */
  {
    global $floodtime, $cookietime;
    // ""  
    $name    = sqlite_escape_string(htmlspecialchars($name));
    $email   = sqlite_escape_string(htmlspecialchars($email));
    $from    = sqlite_escape_string(htmlspecialchars($from));
    $icq     = (integer)$icq; if ($icq == 0) $icq = "";
    $icq     = sqlite_escape_string($icq);
    $url     = str_replace("www.", "http://www.", $url);
    if (!eregi('http://^', $url)) $url = 'http://' . $url;
    $url     = sqlite_escape_string(htmlspecialchars($url));
    $message = str_replace("\n", "[br]", $message);
    $message = str_replace("\r", "", $message);
    $message = sqlite_escape_string(htmlspecialchars($message));
    $now     = time();
    $ip      = get_ip();
    //  Cookies
    setcookie("name",  $name,  time() + $cookietime);
    setcookie("email", $email, time() + $cookietime);
    setcookie("icq",   $icq,   time() + $cookietime);
    setcookie("url",   $url,   time() + $cookietime);
    setcookie("from",  $from,  time() + $cookietime);
    //     
    if (isset($_COOKIE['gb']))
    exit("   $floodtime .<br><a href=\"javascript:history.back()\"></a>");
    setcookie("gb", "done", time() + $floodtime);
    //   
    return sqlite_query($db, "INSERT INTO messages (id, name, email, icq, " .
    "url, message, answer, posted, ip, fromc) VALUES (NULL, '$name', '$email', " .
    "'$icq', '$url', '$message', '', $now, '$ip', '$from')");
  }

  function gbook_show($db, $page)
  /*      */
  {
    global $limit, $theme, $msglen, $namelen, $fromlen;
    $arr = ""; $result = "";
    //    
    $q = sqlite_query($db, "SELECT * FROM messages ORDER BY POSTED ASC " .
    "LIMIT $limit OFFSET " . ($page *  $limit - $limit)) or exit("   .");
    $message_tpl = open_template("./$theme/message.htm");
    //   
    while ($row = sqlite_fetch_array($q, SQLITE_ASSOC))
    {
      $tpl = $message_tpl;
      //  
      $message = substr($row['message'], 0, $msglen);
      $message = str_replace("[br]", "<br>", $message);
      $message = bb_to_tags($message);
      $message = check_url($message);
      $message = text_to_smiles($message);
      $message = wordwrap($message, $msglen, "\r\n", true);
      //  
      $answer = str_replace("[br]", "<br>", $row['answer']);
      $answer = bb_to_tags($answer);
      $answer = check_url($answer);
      $answer = text_to_smiles($answer);
      //   
      $name = substr($row['name'],  0, $namelen);
      $from = substr($row['fromc'], 0, $fromlen);
      //  
      $tpl = str_replace('$name', $name, $tpl);
      $tpl = str_replace('$id',   $row['id'], $tpl);
      if (!empty($row['email']))
      $tpl = str_replace('$email', '<a href="mailto:' . $row['email'] . '">' .
      '<img border="0" src="./' . $theme . '/email.gif"></a>', $tpl);
      else $tpl = str_replace('$email', '', $tpl);
      if (!empty($row['url']))
      $tpl = str_replace('$url', '<a href="'.$htsuf.$row['url'].'">'.
      '<img border="0" src="./'.$theme.'/web.gif"></a>', $tpl);
      else $tpl = str_replace('$url', '', $tpl);
      if (!empty($row['icq']))
      $tpl = str_replace('$icq', '<a href="http://www.icq.com/'.$row['icq'].'">'.
      '<img border="0" src="./'.$theme.'/icq.gif"></a>', $tpl);
      else $tpl = str_replace('$icq', '', $tpl);
      if (!empty($from))
      $tpl = str_replace('$from', $from, $tpl);
      else $tpl = str_replace('$from', "", $tpl);
      $tpl = str_replace('$message', $message, $tpl);
      $tpl = str_replace('$date', format_date($row['posted']), $tpl);
      if (empty($row['answer'])) $row['answer'] = " ";
      $tpl = str_replace('$answer', $row['answer'], $tpl);
      $arr[] = $tpl;
    }
    if (!empty($arr))
    {
      $arr = array_reverse($arr);
      foreach($arr as $v)
      {
        $result .= $v;
      }
      return $result;
    }
  }

  function msg_count($db)
  /*    */
  {
    $count = sqlite_single_query($db, "SELECT count(id) FROM messages");
    return $count;
  }

  function check_url($str)
  /*   */
  {
    $result = $str;
    $result = str_replace("http://www.", "www.", $result);
    $result = str_replace("http://", "www.", $result);
    $result = str_replace("ftp://ftp.", "ftp.", $result);
    $result = str_replace("ftp://", "ftp.", $result);
    $result = eregi_replace("((ftp|www)\.[a-zA-Z0-9\._-]+\.[a-zA-Z]{2,4})",
    '<a target="_blank" style="text-decoration: none" href="http://'."\\1".'">'.
    "\\1".'</a>',
    $result);
    return $result;
  }

  function valid_email($email)
  /*    e-mail  */
  {
    if (eregi("^[a-z0-9\._-]+@[a-z0-9\._-]+\.[a-z]{2,4}\$", $email))
    return true; else return false;
  }

  function bb_to_tags($str)
  /*  bb-  
      HTML- */
  {
    $result = str_replace("[b]", "<b>", $str);
    $result = str_replace("[/b]", "</b>", $result);
    $result = str_replace("[i]", "<i>", $result);
    $result = str_replace("[/i]", "</i>", $result);
    $result = str_replace("[u]", "<u>", $result);
    $result = str_replace("[/u]", "</u>", $result);
    $result = str_replace("[s]", "<s>", $result);
    $result = str_replace("[/s]", "</s>", $result);
    return $result;
  }
  
  function print_navigation($count, $perpage, $page, $mod1, $mod2)
  /*      */
  {
    $pages = ceil($count / $perpage) + 1;
    $first_page = $page - 3; if ($first_page < 1) $first_page = 1;
    $end_page = $page + 4; if ($end_page > $pages) $end_page = $pages;
    if ($count == 0) $count = 1;
    if ($first_page > 1)
    $result .= ' <a class="navigation" href="'.$mod1.'1'.$mod2.'">'.
    '[1]'.'</a> ';
    if ($page > 1)
    $result .= ' <a class="navigation" href="'.$mod1.($page-1).$mod2.
    '">[<<]</a> ';
    for($i = $first_page; $i < $end_page; $i++)
    {
      if ($page == $i)
      $result .= '['.$i.']';
      else
      $result .= ' <a class="navigation" href="'.$mod1.$i.$mod2.'">'.
      '['.$i.']'.'</a> ';
    }
    if ($page < $pages - 1)
    $result .= ' <a class="navigation" href="'.$mod1.($page+1).$mod2.
    '">[>>]</a> ';
    if ($page < $pages - 1 && $end_page < $pages-1)
    $result .= ' <a class="navigation" href="'.$mod1.($pages-1).
    $mod2.'">'.'['.($pages-1).']'.'</a> ';
    return trim($result);
  }
  
  function format_date($time)
  /*   */
  {
    $months = array(1 => "", 2=> "", 3 => "", 4 =>"",
    5 => "", 6 => "", 7 => "", 8 => "", 9 => "",
    10 => "", 11 => "", 12 => "" );
    $days = array(1 => "", 2 => "", 3 => "",
    4 => "", 5 => "", 6 => "", 7 => "");
    $result = $months[date("n", $time)] . " "  . date("j", $time) . ", " . date("Y", $time) .
    " - " . date("H:i:j", $time) . ", " . $days[date("w", $time)];
    return $result;
  }

  function get_ip()
  /*  IP-  */
  {
    if(getenv('HTTP_CLIENT_IP')) 
    $user_ip = getenv('HTTP_CLIENT_IP');
    elseif(getenv('HTTP_X_FORWARDED_FOR'))
    $user_ip = getenv('HTTP_X_FORWARDED_FOR');
    elseif(getenv('REMOTE_ADDR')) 
    $user_ip = getenv('REMOTE_ADDR');
    else $user_ip = '?';
    return $user_ip;
  }

  function open_template($filename)
  /*    
        */
  {
    $content = file($filename);
    $result = "";
    foreach($content as $v)
    {
      $result .= $v;
    }
    return $result;
  }

  function text_to_smiles($str)
  /*      */
  {
    global $db;
    $msg = $str;
    $q = sqlite_query($db, "SELECT * FROM smiles");
    while ($row = sqlite_fetch_array($q, SQLITE_ASSOC))
    {
      $msg = str_replace($row['mask'], '<img src="./smiles/' . $row['file'] . '">',
      $msg);
    }
    return $msg;
  }

  function show_smiles()
  /*        smiles */
  {
    $dir = opendir("./smiles/"); $result = "";
    while (($res = readdir($dir)) !== false)
    {
      if ($res !== ".." and $res !== ".")
      $files[] = $res;
    }
    foreach($files as $v)
    {
      $k = str_replace(".gif", "", $v);
      $result .= '<a href="javascript:puttext(\'*'. $k .'\')"><img border="0" width="20" height="20" src="./smiles/' . $v . '"></a>';
    }
    return $result;
  }

?>
<?php require_once("include_options.php");?>