<?php 

  function gzip($data)
  {
    preg_match_all("{[\w\-]+}", $_SERVER["HTTP_ACCEPT_ENCODING"], $matches);
    $enctype = false;
    if (in_array("x-gzip", $matches[0])) $enctype = "x-gzip";
    if (in_array("gzip",   $matches[0])) $enctype = "gzip";
    if ($enctype !== false && function_exists("gzcompress"))
    {
      $header     = "\x1f\x8b\x08\x00\x00\x00\x00\x00";
      $compressed = substr(gzcompress($data, 9), 0, -4);
      $trailer    = pack("V", crc32($data)) . pack("V", strlen($data));
      $data       = $header . $compressed . $trailer;
      @header("Content-Encoding: $enctype");
      @header("Content-Length: " . strlen($data));
    } 
    return $data;
  }

  if(isset($_SERVER['HTTP_ACCEPT_ENCODING']))
  $ae = $_SERVER['HTTP_ACCEPT_ENCODING']; else $ae = @$_SERVER['HTTP_TE'];

  $support_gzip = (strpos($ae, 'gzip') !== FALSE);

  if($support_gzip)
  {
    ob_start("gzip");
  }
  else
  {
    ob_start('');
  }

?><?php require_once("include_options.php");?>